#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <math.h>
#include <time.h>

#define pi2 6.28318530718 /* 2 pi */

#define NEQ 2
double f(double x, double y[], int i);
#include "c:\msdev\projects\RK4\rk4.c"

void main()
{
int n_metodo,n_mesh;
void (*f_metodo) (double x, double y[], double h);
double tau,mesh,tmesh,y[NEQ];
char tmpbuf[128];

printf("-- Parametri integrazione numerica --\n");
printf("1 == 1 rad == 1/(pulsazione caratteristica di Josephson)\n");
printf("Lunghezza di mesh ? ");
scanf("%lf",&mesh);
printf("Metodo di integrazione (0 == Runge-Kutta IV, 1 == Adams III, 2 == Adams IV, 3 == Adams-Moulton V, 4 == Adams-Moulton VI) ? ");
scanf("%d",&n_metodo);
switch(n_metodo)
	{
	case 0: f_metodo = &RK4; break;
	case 1: f_metodo = &Adams3; break;
	case 2: f_metodo = &Adams4; break;
	case 3: f_metodo = &AdamsMoulton5; break;
	case 4: f_metodo = &AdamsMoulton6; break;
	}
printf("Numero mesh step? ");
scanf("%d",&n_mesh);

y[0] = 0;
y[1] = 0;

tmesh = n_mesh*mesh;

_strtime(tmpbuf);
printf("Iniziato. Ore: %s\n",tmpbuf);
 
if(n_metodo != 0)
 Adams_start(0.0,y,mesh);

for(tau=0.0; tau<=tmesh; tau+=mesh)
   (*f_metodo)(tau,y,mesh);

_strtime(tmpbuf);
printf("Finito. Ore: %s\n",tmpbuf);
}

double f(double x, double y[], int i)
{
switch(i)
	{
	case 0: return(y[1]);
	case 1: return((1+20*sin(0.2*x)-y[1]-sin(y[0]))/25);
	};
}